import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkOrderRefundLog, ThinkOrderRefundLogParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询微信退款记录
 */
export async function pageThinkOrderRefundLog(
  params: ThinkOrderRefundLogParam
) {
  const res = await request.get<ApiResult<PageResult<ThinkOrderRefundLog>>>(
    THINK_API_URL + '/think/think-order-refund-log/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询微信退款记录列表
 */
export async function listThinkOrderRefundLog(
  params?: ThinkOrderRefundLogParam
) {
  const res = await request.get<ApiResult<ThinkOrderRefundLog[]>>(
    THINK_API_URL + '/think/think-order-refund-log',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加微信退款记录
 */
export async function addThinkOrderRefundLog(data: ThinkOrderRefundLog) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-order-refund-log',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改微信退款记录
 */
export async function updateThinkOrderRefundLog(data: ThinkOrderRefundLog) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-order-refund-log',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除微信退款记录
 */
export async function removeThinkOrderRefundLog(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-order-refund-log/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除微信退款记录
 */
export async function removeBatchThinkOrderRefundLog(
  data: (number | undefined)[]
) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-order-refund-log/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询微信退款记录
 */
export async function getThinkOrderRefundLog(id: number) {
  const res = await request.get<ApiResult<ThinkOrderRefundLog>>(
    THINK_API_URL + '/think/think-order-refund-log/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
